
var skoleni = { };

(function () {
    var kontrolaFormulareNaZmenu = function ()
    {
        var form = $('#hodnoceniSkoleni');
        var formular =$(form);
        formular.on("change", 'select', function() {
            formular.data('changed', true);
        });
        formular.on('reset', function() {
            formular.data('changed', false);
            $('input[name="filtr_pritomnych"][value="0"]').click();
        });
        formular.find($('#hodnoceniComboAll')).on('change', function () {
            formular.data('changed', true);

            $("[id*='_hodnoceniCombo']:visible").each(function () {

                if(this.value === "0"){
                    if(debugMode){console.log(this.value);}
                    if(debugMode){console.log(this.id);}

                    $(this).val($('#hodnoceniComboAll').val());
                }
            });
        });
        formular.find($('[id="filtr_pritomnych"]')).change(function ()
        {
            var filtrZobrazeni = $('[id="filtr_pritomnych"]:checked').val();
            var radkySUcastniky = '';
            var licheRadkySUcastniky = '';
            var sudeRadkySUcastniky = '';

            if(filtrZobrazeni === "0"){
                $(".uspesny ").show();
                $(".neuspesne").show();
                $(".bez_hodnoceni").show();
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "1"){
                $(".uspesny ").show();
                $(".neuspesne").hide();
                $(".bez_hodnoceni").hide();
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "2"){
                $(".uspesny ").hide();
                $(".neuspesne").show();
                $(".bez_hodnoceni").hide();
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }

            if(filtrZobrazeni === "3"){
                $(".uspesny ").hide();
                $(".neuspesne").hide();
                $(".bez_hodnoceni").show();
                radkySUcastniky = formular.find($(".radekTabulky:visible"));
                licheRadkySUcastniky = formular.find($(".radekTabulky:visible:even"));
                sudeRadkySUcastniky = formular.find($(".radekTabulky:visible:odd"));
                radkySUcastniky.removeClass("licheRadky");
                radkySUcastniky.removeClass("sudeRadky");
                licheRadkySUcastniky.addClass("licheRadky");
                sudeRadkySUcastniky.addClass("sudeRadky");
            }
        });
    };
    var stornoTlacitko = function ()
    {
        $("[id='tlacitkoStorno']").on('click', function () {
            if($(this).closest('form').data('changed')){
                console.log("Zmena");
                var question = ron.translate('zaznam_upraveny');
                if(!ron.confirm(question)){
                    return false;
                } else {
                    $(this).closest('form').data('changed', false);
                    $(this).closest('form')[0].reset();

                    setTimeout(function () {
                        $('input[name="filtr_pritomnych"][value="0"]').click();
                    }, 500);
                    window.location.href = "?menuid=skoleni&action=skolenikurzy";
                }
            } else {
                $('input[name="filtr_pritomnych"][value="0"]').click();
                window.location.href = "?menuid=skoleni&action=skolenikurzy";
            }
        });
        $(document).keyup(function(e) {
            if (e.keyCode === 27) {
                if(debugMode){console.log("ESC, fn() stornoTlacitko");}

                var filtrZobrazeni = $('[id="filtr_pritomnych"]:checked').val();
                if(filtrZobrazeni !== "0"){
                    $('input[name="filtr_pritomnych"][value="0"]').click();
                } else {
                    $("[id='tlacitkoStorno']").trigger('click');
                }
            }
        })
    };



    var otestujPole = function () {
        var navrat = 1;
        var zprava = "";
        if($("form").hasClass("nonempty"))
        {
            $(".nonempty").each(function () {
                if ($(this).val().trim() === "") {
                    $(this).addClass("app_input_error");
                    zprava += " - " + $(this).attr('title') + "\n";
                    navrat = 0;
                } else {
                    navrat = 1;
                    $(this).removeClass("app_input_error");
                }
            });
            if (navrat === 0) {

                alert(ron.translate('doplnte_chybejici_pole') + "\n" + zprava);
            }
        }
        return navrat;
    };

    var kontrolaVyplneniPoli = function () {

        $("form").submit(function(e){
            if(!otestujPole()){
                e.preventDefault();
            }
        });
    };



    var comboFirmy = function () {
        var $selectFirmy = $(".selectFirmy");
        $selectFirmy.each( nastavSelectFirmy );
    };

    var nastavSelectFirmy = function() {
        var $this = $(this);

        var onFirmaChange = function(index, options) {
            var $firma = $('[name="firma"]');
            $firma.val(options.items[index]['kod']);
        };

        var nactiData = function () {
            $.ajax("?menuid=skoleni&action=seznamfirem")
            .done( function(data) {
                var $firma2 = $('[name="firma2"]');
                var $firma = $('[name="firma"]');

                $firma2.val($firma.val());

                $("#loadingSpinnerFirma").hide();

                if (data.result === "OK") {
                    ron.ronSelect($this, {
                        items: data.items,
                        maxVisibleRows: 30,
                        columns: ["popis", "kod"],
                        valueColumn: "kod",
                        initialValue: $firma.val(),
                        onChange: onFirmaChange,
                        textColumn: "popis"
                    } );
                } else {
                    ron.showError(data);
                }
            })
            .fail( function() {

            }) ;
        };

        nactiData();
    };


    var vycistiDialog = function (dialogDetailuSkoleniKurzu) {
        dialogDetailuSkoleniKurzu.find('.loading').remove();
        dialogDetailuSkoleniKurzu.find('.row').remove();
        dialogDetailuSkoleniKurzu.find('.buttons').remove();
    };


    var pripojeniRadku = function (index, hodnota, dialogDetailuSkoleniKurzu){

        var $divRow = $('<div class="row" />').appendTo(dialogDetailuSkoleniKurzu);
        $divRow.attr('id', index);
        var $divCaption = $('<div class="col col-12 col-sm-3 caption required" />').appendTo($divRow);
        $divCaption.text(ron.translate(index));


        if(hodnota.length > 100){
            var $textareaObsah = $('<textarea class="col col-12 col-sm-9 infomsg" rows="3" cols="70" />').appendTo($divRow);
            $textareaObsah.text(hodnota).attr('disabled', true);
        } else {
            if(index === 'Skoleni_ICAL'){
                var odkaz = $('<a href="'+hodnota+'">'+ron.translate('Skoleni_odkaz_na_download')+'</a>');

                var $divObsah = $('<div class="col col-12 col-sm-9" />').appendTo($divRow);
                $divObsah.wrapInner(odkaz);
            } else {
                var $divObsah = $('<div class="col col-12 col-sm-9" />').appendTo($divRow);
                $divObsah.text(hodnota)
            }
        }
    };


    var pripojeniTlacitek = function (dialogDetailuSkoleniKurzu) {
        var $divButtons = $('<div class="buttons" />').appendTo(dialogDetailuSkoleniKurzu);
        var $divStornoButton = $('<button class="button" id="storno_button" />').appendTo($divButtons);
        $divStornoButton.text('Storno');
        $("#storno_button").on('click', function () {
            $(dialogDetailuSkoleniKurzu).dialog('close');
        });
    };

    var pripojeniSekceKurzu = function () {
        var sekceKurzu = $('.informace-kurzu');
        $(sekceKurzu).on('click', function () {
            $(this).nextUntil('.buttons').toggle();
        });
    };

    var dialogSDetailemSkoleniKurzu = function(){
        var tlacitkoDetailu = $('.zobrazit-detail-skoleni-kurzu');
        var dialogDetailuSkoleniKurzu = $('#detail-skoleni-kurzu');

        $(tlacitkoDetailu).each(function () {
            $(this).on('click', function () {

                var idpp = $(this).attr('data-ron-idpp');
                var druhSkoleni = $(this).attr("data-ron-druhskoleni");
                var datumPovinnosti = $(this).attr("data-ron-datum");
                vycistiDialog(dialogDetailuSkoleniKurzu);
                dialogDetailuSkoleniKurzu.html("<div class='align-center margin-all-2 loading'>" + ron.translate('Probiha_nacitani') + "<i class='position-absolute fa fa-spin glyph-spinner loading-indicator'></i></div>");

                $.ajax({
                            url : "?menuid=skoleni&action=detailnipopisskolenikurzu",
                            type: "GET",
                            data: {
                                idpp: idpp,
                                druhskoleni: druhSkoleni,
                                datum: datumPovinnosti
                            }})
                    .done(function (responseData) {
                        vycistiDialog(dialogDetailuSkoleniKurzu);

                        $.each(responseData, function (index, hodnota)
                        {
                            if(hodnota === 'Skoleni_absolvovane_caption'){
                                var $divSekce = $('<div class="row form-section" />').appendTo(dialogDetailuSkoleniKurzu);
                                $divSekce.text(ron.translate(index));
                                return true;
                            }

                            if(hodnota === 'Skoleni_kurz_caption'){
                                var $divSekce = $('<div class="row form-section informace-kurzu" />').css({cursor: "pointer"}).appendTo(dialogDetailuSkoleniKurzu);
                                var $span = $('<span class="col col-12 col-sm-11 align-left" />');
                                $span.text(ron.translate(index));
                                $divSekce.prepend('<i class="far toggleClass col col-12 col-sm-1 align-right fa-minus-square" data-toggle-class="fa-minus-square fa-plus-square"></i>');
                                $divSekce.prepend($span);

                                return true;
                            }

                            pripojeniRadku(index, hodnota, dialogDetailuSkoleniKurzu);
                        });

                        pripojeniSekceKurzu();
                        pripojeniTlacitek(dialogDetailuSkoleniKurzu);

                    })
                    .fail(function (jqXHR) {
                        ron.showAjaxError(jqXHR, "Data nejsou k dispozici");
                    });


                $(dialogDetailuSkoleniKurzu).dialog({
                    open: function () {$(".ui-widget-overlay").css({opacity: 0.5,backgroundColor: "black"});},
                    resizable: false,
                    modal: true,
                    width: "auto",
                    height: "auto",
                    position: { my: 'center',
                                at: 'top',
                                of: window,
                                collision: 'fit' },
                    title: ron.translate('podrobnosti_skoleni')
                })
            })
        });
    };




    skoleni.vetsiOblastCheckboxu = function(){
        var oblastCheckboxu = $("td.oblastCheckboxu:not(.browserfooter)");

        if(oblastCheckboxu.length !== 0){
            oblastCheckboxu.on('click', function(e) {
                var chk = $(this).find("input:checkbox").get(0);
                if(e.target !== chk && $(chk).length > 0){
                    chk.checked = chk.checked === false;
                    $(this).closest("tr").toggleClass('font-weight-bold', chk.checked);
                }
            });
        }
    };


    $(document).ready(function () {
        kontrolaFormulareNaZmenu();
        stornoTlacitko();
        kontrolaVyplneniPoli();
        comboFirmy();
        dialogSDetailemSkoleniKurzu();
        skoleni.vetsiOblastCheckboxu();




        ron.floatingTableHeaders($('#skoleniHeader'));
    })
})();